/*
 * eeprom.h
 *
 *  Created on: Apr 25, 2023
 *      Author: Flax
 */

#ifndef INC_EEPROM_H_
#define INC_EEPROM_H_

#include "stdlib.h"

// Intrinsic MCU characteristics
#define cNVMeepromBaseAddr				((uint32_t)0x08080000)
#define cNVMeepromLastAddr				((uint32_t)0x080801FF)
#define cNVMeepromSizeFull				(0x200)
#define cNVMeepromEraseSize				(0x4) // Erase granularity - 4B - 32bits

// Architecture
#define cNVMeepromPageSize				(0x20)
#define cNVMeepromPageNumber			(16U)
#define cNVMeepromPageAddr(nb)			(cNVMeepromBaseAddr + (nb * cNVMeepromPageSize))

// Individual pages addresses
#define cNVMeepromPage0Addr				cNVMeepromBaseAddr
#define cNVMeepromPage1Addr				(cNVMeepromPage0Addr + cNVMeepromPageSize)
#define cNVMeepromPage2Addr				(cNVMeepromPage1Addr + cNVMeepromPageSize)
#define cNVMeepromPage3Addr				(cNVMeepromPage2Addr + cNVMeepromPageSize)
#define cNVMeepromPage4Addr				(cNVMeepromPage3Addr + cNVMeepromPageSize)
#define cNVMeepromPage5Addr				(cNVMeepromPage4Addr + cNVMeepromPageSize)
#define cNVMeepromPage6Addr				(cNVMeepromPage5Addr + cNVMeepromPageSize)
#define cNVMeepromPage7Addr				(cNVMeepromPage6Addr + cNVMeepromPageSize)
#define cNVMeepromPage8Addr				(cNVMeepromPage7Addr + cNVMeepromPageSize)
#define cNVMeepromPage9Addr				(cNVMeepromPage8Addr + cNVMeepromPageSize)
#define cNVMeepromPage10Addr			(cNVMeepromPage9Addr + cNVMeepromPageSize)
#define cNVMeepromPage11Addr			(cNVMeepromPage10Addr + cNVMeepromPageSize)
#define cNVMeepromPage12Addr			(cNVMeepromPage11Addr + cNVMeepromPageSize)
#define cNVMeepromPage13Addr			(cNVMeepromPage12Addr + cNVMeepromPageSize)
#define cNVMeepromPage14Addr			(cNVMeepromPage13Addr + cNVMeepromPageSize)
#define cNVMeepromPage15Addr			(cNVMeepromPage14Addr + cNVMeepromPageSize)

#endif /* INC_EEPROM_H_ */
